package com.jasamedika.medifirst2000.controller;

import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.dto.AlatDto;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.AlatService;
import com.jasamedika.medifirst2000.vo.AlatVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

@RestController
@RequestMapping("/alat")
public class AlatController extends LocaleController<AlatVO> {

	private static final Logger LOGGER = getLogger(AlatController.class);

	@Autowired
	private AlatService<AlatVO> alatService;

	@RequestMapping(value = "/find-all-alat/", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> getAllVO(HttpServletRequest request) {
		try {
			Map<String, Object> result = alatService.findAllAlat();
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when findAllAlat", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when findAllAlat", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/save-mesin-cuci", method = POST, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveMesinCuci(@RequestBody AlatDto dto, HttpServletRequest request) {
		Map<String, Object> result = alatService.saveAlat(dto);
		if (!result.isEmpty()) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

	@RequestMapping(value = "/get-all-mesin-cuci", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<List<Map<String, Object>>> getAll(HttpServletRequest request) {
		List<Map<String, Object>> result = alatService.getAllAlat();
		if (result != null) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

	@RequestMapping(value = "/get-mesin-aset", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<List<Map<String, Object>>> getAllRuangan(HttpServletRequest request) {
		List<Map<String, Object>> result = alatService.getAllProdukAset();
		if (result != null) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

	@RequestMapping(value = "/get-satuan", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<List<Map<String, Object>>> getSatuan(HttpServletRequest request) {
		List<Map<String, Object>> result = alatService.getAllSatuanStandar();
		if (result != null) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

	@RequestMapping(value = "/get-departemen-laundry", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> getDepartemenLaundry(HttpServletRequest request) {
		Map<String, Object> result = alatService.getDepartemenLaundry();
		if (result != null) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

	@RequestMapping(value = "/get-max-no-mesin", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> getMaxId(HttpServletRequest request) {
		Map<String, Object> result = alatService.getMaxId();
		if (result != null) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

	@RequestMapping(value = "/get-produkasetid-alatid", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> getProdukAsetAlat(
			@RequestParam(value = "produkAsetId") Integer produkAsetId, @RequestParam(value = "alatId") Integer alatId,
			HttpServletRequest request) {
		Map<String, Object> result = alatService.cekMesiId(produkAsetId, alatId);
		if (result != null) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

	@RequestMapping(value = "/get-asset-laundry", method = GET, produces = APPLICATION_JSON_VALUE)
	public Map<String, Object> gerAssetLaundry(HttpServletRequest request) {
		return this.alatService.findAssetLaundry();
	}

	@RequestMapping(value = "/get-mesin-laundry", method = GET, produces = APPLICATION_JSON_VALUE)
	public Map<String, Object> gerMesinLaundry(HttpServletRequest request) {
		return this.alatService.getMesinLaundry();
	}

}
